import { SafePlugin } from '@atlaskit/editor-common/safe-plugin';
import { REMOVE_HIGHLIGHT_COLOR } from '@atlaskit/editor-common/ui-color';
import { PluginKey } from '@atlaskit/editor-prosemirror/state';
import { getDisabledState } from './utils/disabled';
export const highlightPluginKey = new PluginKey('highlight');
export let HighlightPluginAction = /*#__PURE__*/function (HighlightPluginAction) {
  HighlightPluginAction[HighlightPluginAction["CHANGE_COLOR"] = 0] = "CHANGE_COLOR";
  return HighlightPluginAction;
}({});
export const createPlugin = ({
  api
}) => {
  return new SafePlugin({
    key: highlightPluginKey,
    state: {
      init: () => ({
        activeColor: REMOVE_HIGHLIGHT_COLOR,
        disabled: true
      }),
      apply: (tr, pluginState, _oldState, newState) => {
        var _tr$getMeta;
        const action = (_tr$getMeta = tr.getMeta(highlightPluginKey)) === null || _tr$getMeta === void 0 ? void 0 : _tr$getMeta.type;
        let nextState;
        switch (action) {
          case HighlightPluginAction.CHANGE_COLOR:
            const {
              color
            } = tr.getMeta(highlightPluginKey);
            return {
              ...pluginState,
              activeColor: color
            };
          default:
            nextState = {
              ...pluginState,
              disabled: getDisabledState(newState)
            };
            if (pluginState && pluginState.disabled !== nextState.disabled) {
              return nextState;
            }
            return pluginState;
        }
      }
    }
  });
};