import type { NextEditorPlugin, OptionalPlugin } from '@atlaskit/editor-common/types';
import type { AnalyticsPlugin } from '@atlaskit/editor-plugin-analytics';
import type { PrimaryToolbarPlugin } from '@atlaskit/editor-plugin-primary-toolbar';
import type { TextFormattingPlugin } from '@atlaskit/editor-plugin-text-formatting';
import type { HighlightPluginState } from './pm-plugin';
export type HighlightPlugin = NextEditorPlugin<'highlight', {
    dependencies: [
        OptionalPlugin<AnalyticsPlugin>,
        OptionalPlugin<TextFormattingPlugin>,
        OptionalPlugin<PrimaryToolbarPlugin>
    ];
    sharedState: HighlightPluginState | undefined;
}>;
export declare const highlightPlugin: HighlightPlugin;
